#ifndef VERSION
#define VERSION			"V20A"
#endif

#define IDM_ABOUT		100
#define WTERM_EXIT		101
#define IDM_NAME		102
#define WTERM_CONNECT	201
#define WTERM_SHUTDOWN	202

#define WTERMICON		1

#define IRMX_CHARS      WM_USER+1   // characters received from iRMX

#define MK_FP(seg, off) ((void far*) ((unsigned long) (seg)<<16 | (off)));
#define BUFFER(x, y) *(pBuffer + y * iLineLength +x)

#define MAX_COLUMN		80
#define MAX_ROW			25

#define EOK				0
#define rootjob			3
#define callingtask		0

int PASCAL WinMain(HANDLE, HANDLE, LPSTR, int);
long FAR PASCAL MainWndProc(HWND, unsigned, WORD, LONG);
BOOL FAR PASCAL About(HWND, unsigned, WORD, LONG);
BOOL InitApplication (HANDLE);
HWND InitInstance (HANDLE, int);
void InitWindow (HWND);
void Process_Text_Buffer(HWND, WORD, LPSTR);
void Signal_iRMX(HWND);
void Paint_Window(HWND);
void Scroll_Window_Up (int, int, HWND, HDC);
void Scroll_Window_Down (int, int, HWND, HDC);
void SetUpDC (HWND, HDC);
void ResetDC (HDC);
BOOL Make_Connection(HWND);

extern unsigned pascal RQLookupObject(unsigned, unsigned char far *, unsigned, unsigned far *);
extern void pascal RQSendMessage(unsigned, unsigned, unsigned, unsigned far *);
extern unsigned pascal RQGetTaskTokens(unsigned char, unsigned far *);
extern unsigned pascal RQEGetRmxStatus(void);

HANDLE hInst;			  // current instance

typedef struct {
		 char flag_byte;
		 char data_byte;
		} OUTPUT_BUFFER;

typedef struct {
		 char count;
		 char data_byte[29];
		} INPUT_BUFFER;

unsigned char vm86[12] ={10,'R','?','V','M','8','6','_','J','O','B',0};

unsigned char kb_mb[14] ={12,'R','?','K','B','_'
							,'M','A','I','L','B','O','X',0};

OUTPUT_BUFFER far *out_buf= MK_FP (0x0040, 0xE0);
INPUT_BUFFER  far *in_buf = MK_FP (0x0040, 0xE2);

static unsigned	roottoken;
static unsigned	vm86j;
static unsigned	Kb_Mux;
static unsigned	except;
static unsigned	response;
static unsigned	segment;

static unsigned char KB_Char;
static int		x, y, i;
static char		*pBuffer = NULL;	//pointer to the "virtual" SCREEN
static int		iCharWidth, iCharHeight, iLineLength, iNumberLines;
static int		xCaret, yCaret;

static COLORREF	color_tab [] = {
								RGB(0,0,0),			// 0 = Black
								RGB(0,0,128),		// 1 = Light Blue
								RGB(0,128,0),		// 2 = Light Green
								RGB(0,128,128),		// 3 = Light Cyan
								RGB(128,0,0),		// 4 = Light Red
								RGB(128,0,128),		// 5 = Light Magenta
								RGB(128,128,0),		// 6 = Brown
								RGB(192,192,192),	// 7 = Grey
								RGB(128,128,128),	// 8 = Dark Grey
								RGB(0,0,255),		// 9 = Bright Blue
								RGB(0,255,0),		// a = Bright Green
								RGB(0,255,255),		// b = Bright Cyan
								RGB(255,0,0),		// c = Bright Red
								RGB(255,0,255),		// d = Bright Magenta
								RGB(255,255,0),		// e = Yellow
								RGB(255,255,255)	// f = White
							   };
unsigned char	frg_color, bkg_color;

char	MsgBuff[30];		// Buffer to hold incoming characters
BOOL	Connected = FALSE;		// Flag to indicate if connected
BOOL	Stop_output = FALSE;
BOOL	WinCreated  = FALSE;
short	Routine_index = 0;
HFONT	hOldFont;

